<script>
	import Form from "@/components/Car/Form.svelte"
	import Carousel from "@/components/Car/carousel.svelte"
	import Tabs from "@/components/Car/Tabs.svelte"
	import Benefits from "@/components/Car/Benefits.svelte"
	import CarsCarousel from "@/components/CarsCarousel/Carousel.svelte"

	import { decode } from "html-entities"
	import srcset from "@/helpers/srcset"
	import { isLight } from "@/stores/static"
	import { data as formData } from "@/stores/form"
	import { t, l, locale } from "@/i18n"
	import { isPhone, isTablet } from "@/stores/responsiveness"
	import { onDestroy, onMount, tick } from "svelte"
	import { afterNavigate } from "$app/navigation"
	import { serializeSchema } from "@/helpers/schema"
	
	export let data

	let hidden = false

	$: schema = {
		"@context": "https://schema.org",
		"@type": "Product",
		"image": srcset(data.car.images[0].filename)["x85"],
		"name": data.car.name,
		"category": data.car.brand.name,
		"review": decode(data.car.body[$locale]?.replace(/(<([^>]+)>)/ig, "")),
		"serialNumber": data.car.id
	}

	onMount(() => {
		$formData.variant = data.car.variant_id
	})

	onDestroy(() => $formData.variant = "")

	afterNavigate(async () => {
		hidden = true
		await tick()
		hidden = false
	})
</script>

<svelte:head>
	<link rel=”canonical” href=”https://dcr.ae{$l(`cars$/{data.car.url}`)}”>
	{@html serializeSchema(schema)}
</svelte:head>

<div class="wrap" class:dark={!$isLight}>
	<div class="columns is-flex is-multiline">
		{#if !$isPhone && !$isTablet}
			<div class="column is-4-desktop is-12-tablet is-12-mobile">
				<Form />
			</div>
		{/if}
		<div class="column is-8-desktop is-12-tablet is-12-mobile">
			{#if !hidden}
				<Carousel images={data.car.images} />
			{/if}
			{#if $isPhone || $isTablet}
				<Form />
			{/if}
			<Tabs />
		</div>
	</div>
	<Benefits />
</div>
<div class="more is-clipped">
	<div class="title">
		<h2>{$t("heading.more", { name: data.car.brand.name })}</h2>
	</div>
	<CarsCarousel carsProp="more" />
</div>

<style lang="scss">
	.wrap {
		padding-top: 1.25rem;
		padding-bottom: 1.25rem;
		border-bottom: 1px solid $black;
		transition: border-color .2s ease-in-out;
		&.dark {
			border-color: #434343;
		}
	}
	.columns {
		margin-bottom: 1.75rem;
		:global(.car-carousel) {
			margin-bottom: 2.5rem;
		}
	}

	.more {
		padding: 1rem 0 4rem;
		.title {
			margin-bottom: 4rem;
			h2 {
				font-size: 1.5rem;
				font-weight: 500;
				text-transform: uppercase;
			}
		}
	}
</style>